<!-- 编辑弹窗 -->
<template>
  <ele-modal
    :width="800"
    :visible="visible"
    :maskClosable="false"
    :maxable="maxable"
    :title="isUpdate ? '编辑微信订单表-对账用' : '添加微信订单表-对账用'"
    :body-style="{ paddingBottom: '28px' }"
    @update:visible="updateVisible"
    @ok="save"
  >
    <a-form
      ref="formRef"
      :model="form"
      :rules="rules"
      :label-col="styleResponsive ? { md: 4, sm: 5, xs: 24 } : { flex: '90px' }"
      :wrapper-col="
        styleResponsive ? { md: 19, sm: 19, xs: 24 } : { flex: '1' }
      "
    >
      <a-form-item label="订单时间" name="orderTime">
        <a-input
          allow-clear
          placeholder="请输入订单时间"
          v-model:value="form.orderTime"
        />
      </a-form-item>
      <a-form-item label="微信支付单号" name="wechatNum">
        <a-input
          allow-clear
          placeholder="请输入微信支付单号"
          v-model:value="form.wechatNum"
        />
      </a-form-item>
      <a-form-item label="商户订单号" name="orderNum">
        <a-input
          allow-clear
          placeholder="请输入商户订单号"
          v-model:value="form.orderNum"
        />
      </a-form-item>
      <a-form-item label="交易场景" name="tradeWay">
        <a-input
          allow-clear
          placeholder="请输入交易场景"
          v-model:value="form.tradeWay"
        />
      </a-form-item>
      <a-form-item label="交易状态" name="tradeStatus">
        <a-input
          allow-clear
          placeholder="请输入交易状态"
          v-model:value="form.tradeStatus"
        />
      </a-form-item>
      <a-form-item label="交易金额" name="money">
        <a-input
          allow-clear
          placeholder="请输入交易金额"
          v-model:value="form.money"
        />
      </a-form-item>
      <a-form-item label="对账情况：1=已对账；2=未对账；3=已对账，金额对不上；4=未查询到该订单" name="status">
        <a-radio-group v-model:value="form.status">
          <a-radio :value="0">显示</a-radio>
          <a-radio :value="1">隐藏</a-radio>
        </a-radio-group>
      </a-form-item>
      <a-form-item label="订单类型：order=订单；recharge=充值；user_vip=购卡" name="orderType">
        <a-input
          allow-clear
          placeholder="请输入订单类型：order=订单；recharge=充值；user_vip=购卡"
          v-model:value="form.orderType"
        />
      </a-form-item>
    </a-form>
  </ele-modal>
</template>

<script lang="ts" setup>
  import { ref, reactive, watch } from 'vue';
  import { Form, message } from 'ant-design-vue';
  import { assignObject, uuid } from 'ele-admin-pro';
  import { addThinkWechatBill, updateThinkWechatBill } from '@/api/think/thinkWechatBill';
  import { ThinkWechatBill } from '@/api/think/thinkWechatBill/model';
  import { useThemeStore } from '@/store/modules/theme';
  import { storeToRefs } from 'pinia';
  import { ItemType } from 'ele-admin-pro/es/ele-image-upload/types';
  import { FormInstance } from 'ant-design-vue/es/form';
  import { FileRecord } from '@/api/system/file/model';

  // 是否是修改
  const isUpdate = ref(false);
  const useForm = Form.useForm;
  // 是否开启响应式布局
  const themeStore = useThemeStore();
  const { styleResponsive } = storeToRefs(themeStore);

  const props = defineProps<{
    // 弹窗是否打开
    visible: boolean;
    // 修改回显的数据
    data?: ThinkWechatBill | null;
  }>();

  const emit = defineEmits<{
    (e: 'done'): void;
    (e: 'update:visible', visible: boolean): void;
  }>();

  // 提交状态
  const loading = ref(false);
  // 是否显示最大化切换按钮
  const maxable = ref(true);
  // 表格选中数据
  const formRef = ref<FormInstance | null>(null);
  const images = ref<ItemType[]>([]);

  // 用户信息
  const form = reactive<ThinkWechatBill>({
    id: undefined,
    orderTime: undefined,
    wechatNum: undefined,
    orderNum: undefined,
    tradeWay: undefined,
    tradeStatus: undefined,
    money: undefined,
    status: undefined,
    createTime: undefined,
    orderType: undefined,
    thinkWechatBillId: undefined,
    thinkWechatBillName: '',
    status: 0,
    comments: '',
    sortNumber: 100
  });

  /* 更新visible */
  const updateVisible = (value: boolean) => {
    emit('update:visible', value);
  };

  // 表单验证规则
  const rules = reactive({
    thinkWechatBillName: [
      {
        required: true,
        type: 'string',
        message: '请填写微信订单表-对账用名称',
        trigger: 'blur'
      }
    ]
  });

  const chooseImage = (data: FileRecord) => {
    images.value.push({
      uid: data.id,
      url: data.path,
      status: 'done'
    });
    form.image = data.path;
  };

  const onDeleteItem = (index: number) => {
    images.value.splice(index, 1);
    form.image = '';
  };

  const { resetFields } = useForm(form, rules);

  /* 保存编辑 */
  const save = () => {
    if (!formRef.value) {
      return;
    }
    formRef.value
      .validate()
      .then(() => {
        loading.value = true;
        const formData = {
          ...form
        };
        const saveOrUpdate = isUpdate.value ? updateThinkWechatBill : addThinkWechatBill;
        saveOrUpdate(formData)
          .then((msg) => {
            loading.value = false;
            message.success(msg);
            updateVisible(false);
            emit('done');
          })
          .catch((e) => {
            loading.value = false;
            message.error(e.message);
          });
      })
      .catch(() => {});
  };

  watch(
    () => props.visible,
    (visible) => {
      if (visible) {
        images.value = [];
        if (props.data) {
          assignObject(form, props.data);
          if(props.data.image){
            images.value.push({
              uid: uuid(),
              url: props.data.image,
              status: 'done'
            })
          }
          isUpdate.value = true;
        } else {
          isUpdate.value = false;
        }
      } else {
        resetFields();
      }
    },
    { immediate: true }
  );
</script>
